unit uXmlEditor1; { mk, 14.4.04 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, StdCtrls, msxmldom, XMLDoc, ComCtrls, oxmldom;

type
  TForm1 = class(TForm)
    XDoc: TXMLDocument; bZeigeXML: TButton; OpenDialog1: TOpenDialog;
    tvBaum: TTreeView; mAusgabe: TMemo; bLoesche: TButton;
    mDatei: TMemo; bLadeDatei: TButton;
    procedure bZeigeXMLClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
    procedure bLadeDateiClick(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

procedure TForm1.bZeigeXMLClick(Sender: TObject);
var
  node   : IXMLNode;
  nodes  : IXMLNodeList;
  knoten : TTreeNode;
  s      : string;
  i      : integer;

  procedure erweitereBaum(node : IXMLNode;knoten : TTreeNode);
  var
    nodes      : IXMLNodeList;
    kindknoten : TTreeNode;
    i          : integer;
  begin
    if node.HasChildNodes then
    begin
      nodes := node.ChildNodes;
      for i := 0 to nodes.Count - 1 do
      begin
        case nodes[i].NodeType of
          ntElement   : kindknoten :=
                          tvBaum.Items.AddChild(knoten,'<'+nodes[i].NodeName+'>');
          ntText      : kindknoten :=
                          tvBaum.Items.AddChild(knoten,nodes[i].text);
        end; // of case
        erweitereBaum(nodes[i],kindknoten);
      end;
    end;
  end;

begin
  if Length(mDatei.Text) > 0 then
  try
    tvBaum.Items.Clear;
    XDoc.xml := mDatei.Lines; // zu parsenden Text setzen
    XDoc.Active := true;      // Parsen auslsen
    node := XDoc.DocumentElement;
    nodes := node.AttributeNodes;
    s := '';
    for i := 0 to nodes.Count - 1 do
      s := s + nodes[i].NodeName + ' = ' +nodes[i].NodeValue + '  ';
    knoten := tvBaum.Items.Add(nil,'<'+node.NodeName+'>  '+s);
    erweitereBaum(node,knoten);
  except
    on E:Exception do
      mAusgabe.Lines.Add(E.Message);
  end;
end;

procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mAusgabe.Lines.Clear;
end;

procedure TForm1.bLadeDateiClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    mDatei.Lines.LoadFromFile(OpenDialog1.FileName);
end;

end.
